/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//      Java - grafick uivatelsk prosted a etina        //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      // 
//                       CTI_ME.TXT                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2001                      // 
//                                                             //
/////////////////////////////////////////////////////////////////

// P.Herout 29.11.2000

import java.awt.*;
import java.awt.event.*;

public class TestFontProperties2 extends Frame
                                implements ActionListener {
  final static int velikost = 15;
  Button[][] poleBut;
  String[] napis = {"", "؊\u016Eݎ"};
  String[] rodinyFontu = {"Serif", "SansSerif", "MonoSpaced",
                          "Dialog", "DialogInput"};
  int[] rezy = {Font.PLAIN, Font.BOLD, Font.ITALIC,
                Font.BOLD + Font.ITALIC };
  String[] jmenaRezu = {"Zm\u011b\u0148 n\u00e1pis", 
                        "PLAIN", "BOLD", "ITALIC", "BOLDITALIC"};
  Font popisFn = new Font("SansSerif", Font.PLAIN, 10);
  boolean zobrazenaMala = true;

  public TestFontProperties2() {
    super(" V b\u00edl\u00e9m prostoru mus\u00ed\u0161 vid\u011bt " +
          "12 r\u016fzn\u00fdch font\u016f");
    this.setLayout(new GridLayout(6,5));

    poleBut = new Button[6][];
    poleBut[0] = new Button[5];
    for (int j = 0;  j < 5;  j++) {
      poleBut[0][j] = new Button(jmenaRezu[j]);
      poleBut[0][j].setFont(popisFn);
      add(poleBut[0][j]);
    }
    for (int i = 1;  i < 6;  i++) {
      poleBut[i] = new Button[5];
      poleBut[i][0] = new Button(rodinyFontu[i - 1]);
      poleBut[i][0].setFont(popisFn);
      add(poleBut[i][0]);

      for (int j = 1;  j < 5;  j++) {
        poleBut[i][j] = new Button(napis[0]);
        Font f = new Font(rodinyFontu[i - 1], rezy[j - 1], velikost);
        poleBut[i][j].setFont(f);
        add(poleBut[i][j]);
      }
    }

    nastavBarvy();
    this.setSize(800, 500);
    this.show();

    poleBut[0][0].addActionListener(this);

    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        System.exit(1);
      }
    });
  }

  private void nastavBarvy() {
    poleBut[0][0].setBackground(Color.cyan);
    for (int i = 1;  i < 4;  i++) {
      for (int j = 1;  j < 5;  j++) {
        poleBut[i][j].setBackground(Color.white);
      }
    }
    for (int i = 4;  i < 6;  i++) {
      for (int j = 1;  j < 5;  j++) {
        poleBut[i][j].setBackground(Color.gray);
      }
    }
  }

  public void actionPerformed(ActionEvent e) {
    if (zobrazenaMala == true) {
      zobrazenaMala = false;
      zmenNapis(napis[1]);
    }
    else {
      zobrazenaMala = true;
      zmenNapis(napis[0]);
    }
  }

  private void zmenNapis(String napis) {
    for (int i = 1;  i < 6;  i++) {
      for (int j = 1;  j < 5;  j++) {
        poleBut[i][j].setLabel(napis);
      }
    }
  }

  public static void main(String[] args) {
    TestFontProperties2 t = new TestFontProperties2();
  }
}
