/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//      Java - grafick uivatelsk prosted a etina        //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      // 
//                       CTI_ME.TXT                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2001                      // 
//                                                             //
/////////////////////////////////////////////////////////////////

import java.awt.*;
import java.awt.event.*;

public class MujScrollbar2 extends Zaklad
           implements ActionListener {
  Scrollbar posunSB, velJezdceSB;
  TextField hodnotaTF;
  static final int MIN = 0;
  static final int MAX = 100;

  MujScrollbar2() {
    super.setTitle(getClass().getName());
    posunSB = new Scrollbar(Scrollbar.HORIZONTAL,
                            MAX/2, 0, MIN, MAX + 1);
    hodnotaTF = new TextField(String.valueOf(MAX/2), 3);
    velJezdceSB = new Scrollbar(Scrollbar.HORIZONTAL,
                           1, 0, MIN, 60 + 1);
    this.setLayout(new BorderLayout(5, 5));
    this.add(posunSB, BorderLayout.CENTER);
    this.add(hodnotaTF, BorderLayout.EAST);
    this.add(velJezdceSB, BorderLayout.SOUTH);
    this.setSize(200, 90);

    hodnotaTF.addActionListener(this);

    posunSB.addAdjustmentListener(new AdjustmentListener() {
      public void adjustmentValueChanged(AdjustmentEvent e) {
        int i = posunSB.getValue();
        hodnotaTF.setText(String.valueOf(i));
      }
    });

    velJezdceSB.addAdjustmentListener(new AdjustmentListener() {
      public void adjustmentValueChanged(AdjustmentEvent e) {
        int visible = velJezdceSB.getValue();
        int hod = posunSB.getValue();
        posunSB.setValues(hod, visible, MIN, MAX + visible);
      }
    });
  }

  public void actionPerformed(ActionEvent e) {
    String s = e.getActionCommand();
    int i = Integer.valueOf(s).intValue();
    posunSB.setValue(i);
  }

  public Insets getInsets() {
    return new Insets(34, 10, 10, 10);
  }

  public static void main(String[] args) {
    new MujScrollbar2().setVisible(true);
  }
}
