/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//      Java - grafick uivatelsk prosted a etina        //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      // 
//                       CTI_ME.TXT                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2001                      // 
//                                                             //
/////////////////////////////////////////////////////////////////

import java.awt.*;
import java.awt.event.*;

class Platno extends Canvas {
  private int x1, y1;
  private int x2, y2;
  boolean upda = false;
  boolean pain = true;

  Platno() {
    this.addMouseListener(new ML());
    this.addMouseMotionListener(new MML());
  }

  class ML extends MouseAdapter {
    public void mousePressed(MouseEvent e) {
      setPocatek(e.getX(), e.getY());
    }
    public void mouseReleased(MouseEvent e) {
      setKonec(e.getX(), e.getY());
    }
  }

  class MML extends MouseMotionAdapter {
    public void mouseDragged(MouseEvent e) {
      if (pain == false) {
        Graphics grPl = Platno.this.getGraphics();
        grPl.drawLine(x1, y1, e.getX(), e.getY());
      }
      else
        setKonec(e.getX(), e.getY());
    }
  }

  void setPocatek(int x, int y) {
    x1 = x;
    y1 = y;
  }

  void setKonec(int x, int y) {
    x2 = x;
    y2 = y;
    repaint();
  }

  public void update(Graphics g) {
    if (upda == true)
      paint(g);
    else
      super.update(g);
  }

  public void paint(Graphics g) {
    g.drawLine(x1, y1, x2, y2);
  }
}

public class KresleniMysi extends Frame {
  Checkbox updateCHB, paintCHB;
  Platno pl;

  KresleniMysi() {
    super.setTitle(getClass().getName());
    pl = new Platno();
    this.add(pl, BorderLayout.CENTER);

    updateCHB = new Checkbox("Update", false);
    updateCHB.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        pl.upda = updateCHB.getState();
      }
    } );

    paintCHB = new Checkbox("Paint", true);
    paintCHB.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        pl.pain = paintCHB.getState();
      }
    } );

    Panel p = new Panel();
    p.add(updateCHB);
    p.add(paintCHB);
    this.add(p, BorderLayout.SOUTH);

    this.setSize(180, 150);

    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        System.exit(1);
      }
    });
  }

  public static void main(String[] args) {
    new KresleniMysi().setVisible(true);
  }
}
