/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//      Java - grafick uivatelsk prosted a etina        //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      // 
//                       CTI_ME.TXT                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2001                      // 
//                                                             //
/////////////////////////////////////////////////////////////////

import java.awt.*;
import java.awt.event.*;

class Platno extends Canvas {
  public void paint(Graphics g) {
    Dimension d = getSize();
    g.setColor(Color.lightGray);
    g.fillRect(0, 0, d.width - 1, d.height - 1);
  }
}

class OramovanyPanel extends Panel {
  private final static int OKRAJ = 10;
  public Insets getInsets() {
    return new Insets(OKRAJ, OKRAJ, OKRAJ, OKRAJ);
  }
  
  public void paint(Graphics g) {
    Dimension d = getSize();
    g.drawRect(1, 1, d.width - 3, d.height - 3);
  }
}

public class PohybyMysi extends Frame {
  Label sour1LB, sour2LB, opLB;
  Platno pl;

  PohybyMysi() {
    super.setTitle(getClass().getName());
    opLB = new Label("[000, 000]");
    sour1LB = new Label("[000, 000]");
    sour2LB = new Label("[000, 000]");
    Panel horniP = new Panel();
    horniP.add(opLB);
    horniP.add(sour1LB);
    horniP.add(sour2LB);
    this.add(horniP, BorderLayout.NORTH);

    pl = new Platno();
    OramovanyPanel op = new OramovanyPanel();
    op.setLayout(new BorderLayout());
    op.add(pl, BorderLayout.CENTER);
    this.add(op, BorderLayout.CENTER);

    this.setSize(230, 120);

    pl.addMouseListener(new ML());
    op.addMouseMotionListener(new MML(opLB));
    pl.addMouseMotionListener(new MML(sour1LB));

    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        System.exit(1);
      }
    });
  }

  void vypisSouradnice(int x, int y, Label l) {
    String s = "[" + x + ", " + y + "]";
    l.setText(s);
  }

  class ML extends MouseAdapter {
    public void mousePressed(MouseEvent e) {
      vypisSouradnice(e.getX(), e.getY(), sour1LB);
    }
    public void mouseReleased(MouseEvent e) {
      vypisSouradnice(e.getX(), e.getY(), sour2LB);
    }
  }

  class MML extends MouseMotionAdapter {
    Label kam;
    MML(Label l) { kam = l; }
    public void mouseMoved(MouseEvent e) {
      vypisSouradnice(e.getX(), e.getY(), kam);
    }
  }

  public static void main(String[] args) {
    new PohybyMysi().setVisible(true);
  }
}
