/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//      Java - grafick uivatelsk prosted a etina        //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      // 
//                       CTI_ME.TXT                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2001                      // 
//                                                             //
/////////////////////////////////////////////////////////////////

import java.awt.*;
import java.awt.event.*;

class Platno extends Canvas {
  private int x1, y1;
  private int x2, y2;
  private boolean kruznice = false;

  Platno() {
    this.addMouseListener(new ML());
    this.addMouseMotionListener(new MML());
    this.addKeyListener(new KL());
  }

  class ML extends MouseAdapter {
    public void mousePressed(MouseEvent e) {
      x1 = e.getX(); y1 = e.getY();
    }
  }

  class MML extends MouseMotionAdapter {
    public void mouseDragged(MouseEvent e) {
      x2 = e.getX(); y2 = e.getY();
      repaint();
    }
  }

  class KL extends KeyAdapter {
    public void keyPressed(KeyEvent e) {
      if (e.isShiftDown()) {
        kruznice = true;
        repaint();
      }
    }

    public void keyReleased(KeyEvent e) {
      kruznice = false;
//      repaint();
    }
  }

  public void paint(Graphics g) {
    int sir = x2 - x1;
    int vys = y2 - y1;
    if (kruznice == true) {
      g.setColor(Color.red);
      int prumer = (sir + vys) / 2;
      sir = vys = prumer;
    }
    g.drawOval(x1, y1, sir, vys);
  }
}

public class KresleniElipsy extends Frame {
  KresleniElipsy() {
    super.setTitle(getClass().getName());
    this.add(new Platno(), BorderLayout.CENTER);

    this.setSize(180, 150);

    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        System.exit(1);
      }
    });
  }

  public static void main(String[] args) {
    new KresleniElipsy().setVisible(true);
  }
}
