/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//      Java - grafick uivatelsk prosted a etina        //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      // 
//                       CTI_ME.TXT                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2001                      // 
//                                                             //
/////////////////////////////////////////////////////////////////

import java.awt.*;
import java.awt.event.*;

class Platno extends Canvas {
  private int x1, y1;
  private int x2, y2;
  boolean clp = false;

  Platno() {
    this.addMouseListener(new ML());
    this.addMouseMotionListener(new MML());
  }

  class ML extends MouseAdapter {
    public void mousePressed(MouseEvent e) {
      x1 = e.getX(); y1 = e.getY();
    }
  }

  class MML extends MouseMotionAdapter {
    public void mouseDragged(MouseEvent e) {
      x2 = e.getX(); y2 = e.getY();
      repaint();
    }
  }

  void setClip(boolean b) {
    clp = b;
    repaint();
  }

  public void paint(Graphics g) {
    if (clp == true) {
      Dimension d = getSize();
      g.drawRect(0, 0, d.width / 2, d.height / 2);
      g.setClip(0, 0, d.width / 2, d.height / 2);
      g.setColor(Color.lightGray);
      g.fillRect(1, 1, d.width / 4, d.height / 2);
      g.setColor(Color.yellow);
      g.fillRect(d.width / 4, 1, d.width / 4, d.height / 2);
      g.setXORMode(Color.black);
    }
    g.drawLine(x1, y1, x2, y2);
  }
}

public class Orezavani extends Frame {
  Checkbox clipCHB;
  Platno pl;

  Orezavani() {
    super.setTitle(getClass().getName());
    pl = new Platno();
    this.add(pl, BorderLayout.CENTER);

    clipCHB = new Checkbox("Clip", false);
    clipCHB.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        pl.setClip(clipCHB.getState());
      }
    } );

    Panel p = new Panel();
    p.add(clipCHB);
    this.add(p, BorderLayout.SOUTH);

    this.setSize(180, 150);

    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        System.exit(1);
      }
    });
  }

  public static void main(String[] args) {
    new Orezavani().setVisible(true);
  }
}
