/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//      Java - grafick uivatelsk prosted a etina        //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      // 
//                       CTI_ME.TXT                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2001                      // 
//                                                             //
/////////////////////////////////////////////////////////////////

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;

class Platno extends Canvas implements ImageObserver {
  Image img;
  PostupPrace pp;

  Platno(PostupPrace p) {
   pp = p;
  }

  public boolean imageUpdate(Image im, int info,
                             int x, int y, int w, int h) {
    double celkVyska = (double) im.getHeight(this);
    int proc = (int) ((y / celkVyska) * 100.0);
    pp.setProcenta(proc);
    boolean hotovo = ((info  &  (ERROR | ALLBITS)) != 0);
    if (hotovo)
      repaint();
    return !hotovo;
  }

  void nactiObrazek(String jmeno) {
    Toolkit t = this.getToolkit();
    img = t.getImage(jmeno);
    pp.nulujProcenta();
    repaint();
  }

  public void paint(Graphics g) {
    Dimension d = getSize();
    if (img != null)
      g.drawImage(img, 0, 0, d.width - 1, d.height - 1, this);
  }
}

public class NacitaniObrazku3 extends Frame {
  Platno pl;
  PostupPrace pp;

  NacitaniObrazku3() {
    super.setTitle(getClass().getName());
    pp = new PostupPrace(true);
    pl = new Platno(pp);
    this.add(pl, BorderLayout.CENTER);

    Button b1 = new Button("Prvn obrzek");
    b1.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        String fs = System.getProperty("file.separator");
        pl.nactiObrazek(".." + fs + "kouzelnik.jpg");
//        pl.nactiObrazek("kouzelnik.jpg");
      }
    });

    Button b2 = new Button("Druh obrzek");
    b2.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        String fs = System.getProperty("file.separator");
        pl.nactiObrazek(".." + fs + "kocka.jpg");
//        pl.nactiObrazek("kocka.jpg");
      }
    });

    Panel p = new Panel();
    p.add(b1);
    p.add(pp);
    p.add(b2);
    this.add(p, BorderLayout.SOUTH);

    this.setSize(350, 250);

    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        System.exit(1);
      }
    });
  }

  private final static int OKRAJ = 10;
  public Insets getInsets() {
    return new Insets(OKRAJ * 3, OKRAJ, OKRAJ, OKRAJ);
  }

  public static void main(String[] args) {
    new NacitaniObrazku3().setVisible(true);
  }
}

class PostupPrace extends Canvas {
  private int procent = 0;
  private static final int OKRAJ = 3;
  private int vys = 10 + OKRAJ * 2;
  private boolean zobrazovatCislo;

  public PostupPrace(boolean zobrazovat) {
    zobrazovatCislo = zobrazovat;
  }

  public void nulujProcenta() {
    procent = 0;
  }

  public void setProcenta(int p) {
    if (procent < p) {
      procent = p;
      repaint();
    }
  }

  public Dimension getMinimumSize() {
    return new Dimension(102, vys);
  }

  public Dimension getPreferredSize() {
    return getMinimumSize();
  }

  public void paint(Graphics g) {
    Dimension d = getSize();
    g.setColor(Color.blue);
    if (procent >= 99)
      procent = 100;
    if (zobrazovatCislo == true) {
      g.clearRect(1, 1, d.width - 2, d.height - 2);
      String s = "" + procent + "%";
      FontMetrics fm = g.getFontMetrics();
      int sir = fm.stringWidth(s);
      int xc = (d.width - sir) / 2;
      g.drawString(s, xc, d.height - 1 - OKRAJ);
      g.setXORMode(Color.white);
    }
    g.drawRect(0, 0, d.width - 1, d.height - 1);
    double p = procent / 100.0;
    int xp = (int) (p * d.width);
    g.fillRect(1, 1, xp - 2 , d.height - 2);
  }
}


