/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//      Java - grafick uivatelsk prosted a etina        //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      // 
//                       CTI_ME.TXT                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2001                      // 
//                                                             //
/////////////////////////////////////////////////////////////////

import java.awt.*;
import java.awt.event.*;

class Platno extends Canvas {
  Image img;
  int sirka, vyska;
  boolean cely = false, zmenseny = true,
          natazeny = false;

  Platno() {
    Toolkit t = this.getToolkit();
    MediaTracker mt = new MediaTracker(this);
    String fs = System.getProperty("file.separator");
    img = t.getImage(".." + fs + "kocka.jpg");
//    img = t.getImage("kocka.jpg");
    mt.addImage(img, 0);
    try { mt.waitForAll(); }
    catch (InterruptedException e) {
      e.printStackTrace();
    }
    sirka = img.getWidth(this);
    vyska = img.getHeight(this);
  }

  void vykresliObrazek(boolean c, boolean z, boolean n) {
    cely = c;
    zmenseny = z;
    natazeny = n;
    repaint();
  }

  public void paint(Graphics g) {
    Dimension d = getSize();
    double pomerx = (double) d.width / sirka;
    int px = d.width;
    int py = (int) (vyska * pomerx);
    int dy = (d.height - py) / 2;
    int dx = 0;
    if (py > d.height) {
      double pomery = (double) d.height / vyska;
      px = (int) (sirka * pomery);
      py = d.height;
      dx = (d.width - px) / 2;
      dy = 0;
    }

    if (cely == true)
      g.drawImage(img, 0, 0, this);
    if (zmenseny == true)
      g.drawImage(img, dx, dy, px, py, this);
    if (natazeny == true)
      g.drawImage(img, 0, 0, d.width - 1, d.height - 1, this);
  }
}

public class ZobrazeniObrazku extends Frame {
  Platno pl;

  ZobrazeniObrazku() {
    super.setTitle(getClass().getName());
    this.setSize(300, 200);
    pl = new Platno();
    this.add(pl, BorderLayout.CENTER);

    Button b1 = new Button("Cel");
    b1.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        pl.vykresliObrazek(true, false, false);
      }
    });

    Button b2 = new Button("Zmenen");
    b2.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        pl.vykresliObrazek(false, true, false);
      }
    });

    Button b3 = new Button("Nataen");
    b3.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        pl.vykresliObrazek(false, false, true);
      }
    });

    Panel p = new Panel();
    p.add(b1);
    p.add(b2);
    p.add(b3);
    this.add(p, BorderLayout.SOUTH);

    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        System.exit(1);
      }
    });
  }

  public static void main(String[] args) {
    new ZobrazeniObrazku().setVisible(true);
  }
}


