/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//      Java - grafick uivatelsk prosted a etina        //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      // 
//                       CTI_ME.TXT                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2001                      // 
//                                                             //
/////////////////////////////////////////////////////////////////

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;

class Platno extends Canvas {
  Image img = null;

  public Dimension getMinimumSize() {
    return new Dimension(VlastniObrazek.ROZSAH,
                         VlastniObrazek.ROZSAH);
  }

  public Dimension getPreferredSize() {
    return getMinimumSize();
  }

  void vykresliObrazek(Image img) {
    this.img = img;
    repaint();
  }

  public void update(Graphics g) {
    paint(g);
  }

  public void paint(Graphics g) {
    Dimension d = getSize();
    if (img != null)
      g.drawImage(img, 0, 0, d.width - 1, d.height - 1, this);
  }
}

public class VlastniObrazek extends Frame {
  public static final int ROZSAH = 256;
  Platno pl;
  Image img;
  int[] pixel = new int[ROZSAH * ROZSAH];
  Scrollbar zelenaSB;

  VlastniObrazek() {
    super.setTitle(getClass().getName());
    pl = new Platno();
    this.add(pl, BorderLayout.CENTER);

    zelenaSB = new Scrollbar(Scrollbar.HORIZONTAL,
                             ROZSAH / 2, 1, 0, ROZSAH);
    zelenaSB.setBackground(new Color(0, ROZSAH / 2, 0));
    img = pripravObrazek(ROZSAH / 2);
    pl.vykresliObrazek(img);
    zelenaSB.addAdjustmentListener(new AdjustmentListener() {
      public void adjustmentValueChanged(AdjustmentEvent e) {
        int z = zelenaSB.getValue();
        img = pripravObrazek(z);
        pl.vykresliObrazek(img);
        zelenaSB.setBackground(new Color(0, z, 0));
      }
    });

    this.add(zelenaSB, BorderLayout.SOUTH);
    this.pack();
    
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        System.exit(1);
      }
    });
  }

  private final static int OKRAJ = 10;
  public Insets getInsets() {
    return new Insets(OKRAJ * 3, OKRAJ, OKRAJ, OKRAJ);
  }


  Image pripravObrazek(int zelena) {
    int index = 0;
    for (int cervena = 0;  cervena < ROZSAH;  cervena++) {
      for (int modra = 0;  modra < ROZSAH;  modra++) {
        pixel[index++] = (255 << 24) + (cervena << 16) +
                         (zelena << 8) + modra;
      }
    }
    MemoryImageSource mis = new MemoryImageSource(ROZSAH, ROZSAH,
                                  pixel, 0, ROZSAH);
    return createImage(mis);
  }

  public static void main(String[] args) {
    new VlastniObrazek().setVisible(true);
  }
}


