/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//      Java - grafick uivatelsk prosted a etina        //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      // 
//                       CTI_ME.TXT                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2001                      // 
//                                                             //
/////////////////////////////////////////////////////////////////

import java.io.*;
import java.text.*;
import java.awt.*;
import java.awt.event.*;

public class BreakIterator2 extends Zaklad {
  TextArea vstupTA;
  Label vysledekLB;
  Button nactiBT;
  BreakIterator wbi, lbi;

  BreakIterator2() {
    super.setTitle(getClass().getName());
    nactiBT = new Button("Nati soubor");
    this.add(nactiBT);
    vysledekLB = new Label("Zde bude vybran slovo");
    this.add(vysledekLB);
    vstupTA = new TextArea("Njak esk text.",
          5, 30, TextArea.SCROLLBARS_BOTH);
    Font f = new Font("MonoSpaced", Font.PLAIN, 12);
    vstupTA.setFont(f);
    this.add(vstupTA);
    wbi = BreakIterator.getWordInstance();
    lbi = BreakIterator.getLineInstance();
    this.setSize(250, 150);

    vstupTA.addMouseListener(new ML());
    nactiBT.addActionListener(new AL());
  }

  class ML extends MouseAdapter {
    public void mouseClicked(MouseEvent e) {
      int i = vstupTA.getCaretPosition();
      wbi.setText(vstupTA.getText());
      int z = wbi.preceding(i);
      int k = wbi.following(i);
      vstupTA.setSelectionStart(z);
      vstupTA.setSelectionEnd(k);
      String s = "|" + vstupTA.getSelectedText() + "| ";
      vysledekLB.setText(s + z + ", " + i + ", " + k);
     }
  }

  class AL implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      String s = nactiSoubor();
      s = zalamejRadky(s);
      vstupTA.setText(s);
    }
  }

  String nactiSoubor() {
    String s = null;
    try {
      FileReader fr = new FileReader("vety.txt");
      BufferedReader bfr = new BufferedReader(fr);
      StringWriter sout = new StringWriter();
      String radka;
      while ((radka = bfr.readLine()) != null)
        sout.write(radka + " ");
      bfr.close();
      sout.close();
      s = sout.toString();
    }
    catch (IOException e) {
      e.printStackTrace();
    }
    return (s);
  }

  String zalamejRadky(String s) {
    lbi.setText(s);
    int zac = lbi.first();
    int kon = lbi.next();
    int delkaRadky = 0;
    int maxDelkaRadky = vstupTA.getColumns();
    String or = System.getProperty("line.separator");
    StringBuffer sb = new StringBuffer(s.length() * 2);

    while (kon != BreakIterator.DONE) {
      String slovo = s.substring(zac, kon);
      delkaRadky += slovo.length();
      if (delkaRadky >= maxDelkaRadky) {
        sb.append(or);
	      delkaRadky = slovo.length();
      }
      sb.append(slovo);
	    zac = kon;
      kon = lbi.next();
    }
    return (new String(sb));
  }

  public static void main(String[] args) {
    new BreakIterator2().setVisible(true);
  }
}
