/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//      Java - grafick uivatelsk prosted a etina        //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      // 
//                       CTI_ME.TXT                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2001                      // 
//                                                             //
/////////////////////////////////////////////////////////////////

import java.util.*;
import java.awt.*;
import java.awt.event.*;

class Citac extends Observable {
  protected int hodnota;

  public Citac(int hodnota) {
    setHodnota(hodnota);
  }

  public void setHodnota(int hodnota) {
    this.hodnota = hodnota;
    setChanged();   // doslo ke zmene
    // zmena je reprezentovana novym objektem
    notifyObservers(new Integer(hodnota));
  }

  public void plusJedna() {
    setHodnota(++hodnota);
  }

  public void minusJedna() {
    setHodnota(--hodnota);
  }
}

class CitacTextField extends TextField implements Observer {
  CitacTextField(int hodnota) {
    this.setColumns(6);
    this.setEditable(false);
    this.setText("" + hodnota);
  }

  public void update(Observable o, Object arg) {
    this.setText(arg.toString());
  }
}

class CitacScrollbar extends Scrollbar implements Observer {
  CitacScrollbarObserver o;

  CitacScrollbar(int hodnota, int min, int max) {
    super(Scrollbar.HORIZONTAL, hodnota, 0, min, max);
    o = new CitacScrollbarObserver();
    this.addAdjustmentListener(o);
  }

  public void update(Observable o, Object arg) {
    int pozice = ((Integer) arg).intValue();
    this.setValue(pozice);
  }

  class CitacScrollbarObserver extends Observable implements AdjustmentListener {
    public void adjustmentValueChanged(AdjustmentEvent e) {
      int pozice = CitacScrollbar.this.getValue();
      setChanged();
      notifyObservers(new Integer(pozice));
    }
  }
}

public class MujObserver2 extends Frame {
  Citac citac;
  CitacTextField ctf;
  CitacScrollbar csb;
  Button plusBT, minusBT;

  MujObserver2() {
    super.setTitle(getClass().getName());
    this.setLayout(new BorderLayout(10, 10));

    minusBT = new Button(" -1 ");
    this.add(minusBT, BorderLayout.WEST);
    minusBT.addActionListener(new MinusBT());

    ctf = new CitacTextField(0);
    this.add(ctf, BorderLayout.CENTER);

    plusBT = new Button(" +1 ");
    this.add(plusBT, BorderLayout.EAST);
    plusBT.addActionListener(new PlusBT());

    csb = new CitacScrollbar(0, -10, 10) ;
    this.add(csb, BorderLayout.SOUTH);

    citac = new Citac(0);
    citac.addObserver(ctf);
    citac.addObserver(csb);
    csb.o.addObserver(ctf);

    this.pack();

    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        System.exit(0);
      }
    });
  }

  class PlusBT implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      citac.plusJedna();
    }
  }

  class MinusBT implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      citac.minusJedna();
    }
  }

  public static void main(String[] args) {
    new MujObserver2().setVisible(true);
  }
}
