/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//      Java - grafick uivatelsk prosted a etina        //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      // 
//                       CTI_ME.TXT                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2001                      // 
//                                                             //
/////////////////////////////////////////////////////////////////

import java.awt.*;
import java.awt.event.*;

class MujDialog extends Dialog {
  Dialog d;
  GridBagLayout gbl;
  GridBagConstraints gbc;

  void vytvorTlacitko(String jmeno, int gridwidth) {
    Button b = new Button(jmeno);
    gbc.gridwidth = gridwidth;
    gbl.setConstraints(b, gbc);
    add(b);
  }

  MujDialog(Frame f, GridBagConstraints gbc) {
    super(f, "GridBagLayout", false);
    d = this;
    this.gbc = gbc;

    gbl = new GridBagLayout();
    this.setLayout(gbl);
    vytvorTlacitko("Tl. 1", GridBagConstraints.RELATIVE);
    double x = gbc.weightx;
    double y = gbc.weighty;
    gbc.weightx = 0.0;
    gbc.weighty = 0.0;
    vytvorTlacitko("Tla. 2", GridBagConstraints.REMAINDER);
    vytvorTlacitko("Tlatko 3", GridBagConstraints.RELATIVE);
    vytvorTlacitko("T. 4", GridBagConstraints.REMAINDER);
    gbc.weightx = x;
    gbc.weighty = y;

    this.addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        d.dispose();
      }
    });
    this.setLocation(250, 100);
    this.setSize(200, 200);
    this.show();
  }
}

public class MujGridBagLayout3 extends Zaklad {
  GridBagConstraints gbc;
  Choice fillCh, anchorCh;
  TextField ipadTF, insetsTF, wxTF, wyTF;

  int[] fillK = {GridBagConstraints.NONE,
                 GridBagConstraints.HORIZONTAL,
                 GridBagConstraints.VERTICAL,
                 GridBagConstraints.BOTH };
  String[] fillN = {"NONE", "HORIZONTAL",
                    "VERTICAL", "BOTH" };
  int[] anchorK = {GridBagConstraints.CENTER,
                   GridBagConstraints.NORTH,
                   GridBagConstraints.NORTHEAST,
                   GridBagConstraints.EAST,
                   GridBagConstraints.SOUTHEAST,
                   GridBagConstraints.SOUTH,
                   GridBagConstraints.SOUTHWEST,
                   GridBagConstraints.WEST,
                   GridBagConstraints.NORTHWEST };
  String[] anchorN = {"CENTER", "NORTH", "NORTHEAST",
                      "EAST", "SOUTHEAST", "SOUTH",
                      "SOUTHWEST", "WEST", "NORTHWEST" };
  Frame f;

  MujGridBagLayout3() {
    f = this;
    super.setTitle(getClass().getName());
    this.setLayout(new GridLayout(6, 2, 10, 10));
    this.add(new Label("fill", Label.RIGHT));
    fillCh = new Choice();
    for (int i = 0;  i < fillN.length;  i++)
      fillCh.add(fillN[i]);
    this.add(fillCh);
    fillCh.addItemListener(new FIL());

    this.add(new Label("anchor", Label.RIGHT));
    anchorCh = new Choice();
    for (int i = 0;  i < anchorN.length;  i++)
      anchorCh.add(anchorN[i]);
    this.add(anchorCh);
    anchorCh.addItemListener(new AIL());

    this.add(new Label("ipadxy", Label.RIGHT));
    ipadTF = new TextField("0");
    this.add(ipadTF);
    ipadTF.addActionListener(new IpadAL());

    this.add(new Label("insets", Label.RIGHT));
    insetsTF = new TextField("0");
    this.add(insetsTF);
    insetsTF.addActionListener(new InsetsAL());

    this.add(new Label("Tl. 1 - weightx", Label.RIGHT));
    wxTF = new TextField("0.0");
    this.add(wxTF);
    wxTF.addActionListener(new WXAL());

    this.add(new Label("Tl. 1 - weighty", Label.RIGHT));
    wyTF = new TextField("0.0");
    this.add(wyTF);
    wyTF.addActionListener(new WYAL());

    gbc = new GridBagConstraints();
    this.pack();
  }

  class FIL implements ItemListener {
    public void itemStateChanged(ItemEvent e) {
      int i = fillCh.getSelectedIndex();
      gbc.fill = fillK[i];
      new MujDialog(f, gbc);
    }
  }

  class AIL implements ItemListener {
    public void itemStateChanged(ItemEvent e) {
      int i = anchorCh.getSelectedIndex();
      gbc.anchor = anchorK[i];
      new MujDialog(f, gbc);
    }
  }

  class IpadAL implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      int i = Integer.parseInt(ipadTF.getText());
      gbc.ipadx = i;
      gbc.ipady = i;
      new MujDialog(f, gbc);
    }
  }

  class InsetsAL implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      int i = Integer.parseInt(insetsTF.getText());
      gbc.insets = new Insets(i, i, i, i);
      new MujDialog(f, gbc);
    }
  }

  class WXAL implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      double d = Double.parseDouble(wxTF.getText());
      gbc.weightx = d;
      new MujDialog(f, gbc);
    }
  }

  class WYAL implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      double d = Double.parseDouble(wyTF.getText());
      gbc.weighty = d;
      new MujDialog(f, gbc);
    }
  }

  public static void main(String[] args) {
    new MujGridBagLayout3().setVisible(true);
  }
}
