/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//      Java - grafick uivatelsk prosted a etina        //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      // 
//                       CTI_ME.TXT                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2001                      // 
//                                                             //
/////////////////////////////////////////////////////////////////

import java.awt.*;
import java.awt.event.*;

class Platno extends Canvas {
  private String jmeno = "Serif";
  private int velikost = 8;

  public void zmenJmeno(String jm) {
    jmeno = jm;
    repaint();
  }

  public void zmenVelikost(int vel) {
    velikost = vel;
    repaint();
  }

  public void paint(Graphics g) {
    Dimension d = getSize();
    int druhySloupec = d.width / 2;
    int posunRadky = g.getFontMetrics().getHeight();

    Font f = new Font(jmeno, Font.PLAIN, velikost);
    FontMetrics fm = g.getFontMetrics(f);
    String s = "Height: " + fm.getHeight();
    g.drawString(s, 0, 1 * posunRadky);
    s = "Ascent: " + fm.getAscent();
    g.drawString(s, 0, 2 * posunRadky);
    s = "Descent: " + fm.getDescent();
    g.drawString(s, 0, 3 * posunRadky);
    s = "Leading: " + fm.getLeading();
    g.drawString(s, 0, 4 * posunRadky);

    s = "Velikost fontu: " + f.getSize();
    g.drawString(s, druhySloupec, 1 * posunRadky);
    s = "MaxAscent: " + fm.getMaxAscent();
    g.drawString(s, druhySloupec, 2 * posunRadky);
    s = "MaxDescent: " + fm.getMaxDescent();
    g.drawString(s, druhySloupec, 3 * posunRadky);

    g.setFont(f);
    s = "apk";
    int x = (d.width - fm.stringWidth(s)) / 2;
    g.drawString(s, x, d.height - fm.getDescent());
  }
}

public class VyskaTextu extends Frame {
  Choice jmenaCH, velikostiCH;
  String[] jmena = {"Serif", "SansSerif", "MonoSpaced" };
  Platno pl;

  VyskaTextu() {
    super.setTitle(getClass().getName());
    pl = new Platno();
    this.add(pl, BorderLayout.CENTER);

    jmenaCH = new Choice();
    for (int i = 0;  i < jmena.length;  i++) {
      jmenaCH.add(jmena[i]);
    }
    jmenaCH.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        pl.zmenJmeno(jmenaCH.getSelectedItem());
      }
    } );

    velikostiCH = new Choice();
    for (int i = 8;  i <= 30;  i += 2) {
      velikostiCH.add(String.valueOf(i));
    }
    velikostiCH.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        int vel = Integer.parseInt(velikostiCH.getSelectedItem());
        pl.zmenVelikost(vel);
      }
    } );

    Panel p = new Panel();
    p.add(jmenaCH);
    p.add(velikostiCH);
    this.add(p, BorderLayout.SOUTH);

    this.setSize(220, 170);

    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        System.exit(1);
      }
    });
  }

  private final static int OKRAJ = 10;
  public Insets getInsets() {
    return new Insets(OKRAJ * 3, OKRAJ, OKRAJ, OKRAJ);
  }

  public static void main(String[] args) {
    new VyskaTextu().setVisible(true);
  }
}
