/////////////////////////////////////////////////////////////////
//                                                             //
// Tento zdrojov kd je soust distribuce balku program,  //
//     poskytovanch jako doplujc informace ke knize        //
//                                                             //
//      Java - grafick uivatelsk prosted a etina        //
//                                                             //
//     Pette si, prosm, dkladn upozornn v souboru      // 
//                       CTI_ME.TXT                            //
//        kter je nedlnou soust tto distribuce           //
//                                                             //
//                 (c) Pavel Herout, 2001                      // 
//                                                             //
/////////////////////////////////////////////////////////////////

import java.io.*;

public class CeskyRAF extends RandomAccessFile {
  String kodovani;

  public CeskyRAF(String jmeno, String mod, String kodovani)
                              throws FileNotFoundException {
    super(jmeno, mod);
    this.kodovani = kodovani;
  }

  public String ctiRadku() {
    try {
      PipedOutputStream pos = new PipedOutputStream();
      PipedInputStream pis = new PipedInputStream(pos);
      int pocet = 0;
      int b;

      try {
        while ((b = readByte()) != '\n') {
          pos.write(b);
          pocet++;
        }
      }
      catch (EOFException e) {
        if (pocet == 0)
          return null;
      }

      pos.close();
      InputStreamReader isr = new InputStreamReader(pis, kodovani);
      BufferedReader bisr = new BufferedReader(isr);
      String s = bisr.readLine();
      return s;
    }
    catch (IOException e) {
      e.printStackTrace();
    }
    return null;
  }

  public void zapisRadku(String radka) {
    try {
      String or = System.getProperty("line.separator");
      int delka = radka.length() + or.length();
      PipedOutputStream pos = new PipedOutputStream();
      OutputStreamWriter wpos = new OutputStreamWriter(pos, kodovani);
      PrintWriter pwpos = new PrintWriter(wpos);
      PipedInputStream pis = new PipedInputStream(pos);
      pwpos.println(radka);
      pwpos.close();
      pos.close();
      byte[] pole = new byte[delka];
      pis.read(pole, 0, delka);
      write(pole, 0, delka);
    }
    catch (IOException e) {
      e.printStackTrace();
    }
  }


  public static void main(String[] args)
                                throws IOException {
    CeskyRAF fr = new CeskyRAF("vystup.Cp1250", "r", "Cp1250");
    CeskyRAF frw = new CeskyRAF("Cp852.txt", "rw", "Cp852");

    String radka;
    while ((radka = fr.ctiRadku()) != null) {
      frw.zapisRadku(radka);
    }
    fr.close();
    frw.close();
  }
}

